unit operands;

interface
type
 tvectordata = array of integer;
 TOperand = class
  function plus(op:TOperand):TOperand;virtual;abstract;
  function multiply(op:TOperand):TOperand;virtual;abstract;
  procedure display;virtual;abstract;
 end;

 TVector = class(TOperand)
  data:TVectorData;
  constructor init(size:integer);overload;
  constructor init(data:TVectorData);overload;
  function plus(op:TOperand):TOperand;override;
  function multiply(op:TOperand):TOperand;override;
  procedure display;override;
 end;

 TReal = class(TOperand)
  data:real;
  constructor init(data:real);
  function plus(op:TOperand):TOperand;override;
  function multiply(op:TOperand):TOperand;override;
  procedure display;override;
 end;
implementation


{ TVector }

procedure TVector.display;
var i:integer;
begin
 write('(');
 for i := low(data) to high(data) do
 begin
  if i< high(data) then
   write(data[i],', ')
  else write(data[i]);
 end;
 writeln(')');
end;

constructor TVector.init(size: integer);
var i:integer;
begin
 setlength(data,size);
 for i:= 0 to size - 1 do
  data[i] := random(10);
end;

constructor TVector.init(data: TVectorData);
begin
 self.data := data;
end;

function TVector.multiply(op: TOperand): TOperand;
var pom:TVector;
    res:real;
    i:integer;
begin
 if op is TVector then
 begin
  pom := op as TVector;
  if length(pom.data) = length(data) then
  begin
   res := 0;
   for i:=low(data) to high(data) do
    res := res + pom.data[i]*data[i];
   multiply := TReal.init(res); 
  end
  else multiply := TVector.init(0);
 end
 else multiply := TVector.init(0);

end;

function TVector.plus(op: TOperand): TOperand;
var res:tvectordata;
    pom:TVector;
    i:integer;
begin
 if op is TVector then
 begin
  pom:=op as TVector;
  if length(pom.data) = length(data) then
  begin
   setLength(res,length(data));
   for i := low(data) to high(data) do
    res[i] := data[i] + pom.data[i];
   plus:= TVector.init(res);
  end
  else plus := TVector.init(0);
 end
 else plus := TVector.init(0);

end;

{ TReal }

procedure TReal.display;
begin
  writeln(data:0:5);
end;

constructor TReal.init(data: real);
begin
 self.data := data;
end;

function TReal.multiply(op: TOperand): TOperand;
begin
 if op is TReal then
 begin
  multiply:= TReal.init((op as TReal).data * data);
 end
 else multiply:=TVector.init(0);
end;

function TReal.plus(op: TOperand): TOperand;
begin
 if op is TReal then
 begin
  plus:= TReal.init((op as TReal).data + data);
 end
 else plus:=TVector.init(0);
end;
begin
 randomize;
end.
